#include<stdio.h>
#include<stdlib.h>
#include<time.h>


void createHeap( int * , int );
int findMin(int *, int );
void Qsort(int *, int, int);
int insert(int *, int  ,int );
int merge(int *, int , int *, int );
int deleteMin(int *, int );
void sorting(int*,int );


//I main pou xrisimpoiithike gia tin eksagogi tou teleftaiou peiramatos
int main()
{
  int i=0, new_el, *new_list,new_length, length;
  int *list=0;
  int sec;

  list = malloc(300000*sizeof(int));

  do
  {  
	  *(list+i)=rand();
	  i++;
  }while(i!=100000);
  length=i-1;

  printf("List is :\n");
  for(i=0;i<length;i++)
  { 
	  printf("%8d", *(list+i));
  }
  
  sec=time(0);
  createHeap(list,length);
  printf("\ntime of execution of createHeap=%3d\n",(time(0)-sec));
  
  printf("\n\nHeapified list is :\n");
  for(i=0;i<length;i++)
  {
	  printf("%8d",*(list+i));
  }
  
  sec=time(0);
  findMin(list,length);
  printf("\ntime of execution of findMin=%3d\n",(time(0)-sec));
  
  printf("Please give the new element that you want to insert to the heap\n");
  scanf("%d", &new_el);
  sec=time(0);
  length=insert(list,length,new_el);
  printf("\ntime of execution of insert=%3d\n",(time(0)-sec));
  printf("\n\nHeapified list (with the add of the new element) is :\n");
  for(i=0;i<length;i++)
  {
	  printf("%8d",*(list+i));
  }

  new_list = malloc(100000*sizeof(int));
  i=0;
  do
  {  
	  *(new_list+i)=rand();
	  i++;
  }while(i!=10000);
  new_length=i-1;
  sec=time(0);
  length=merge(list,length,new_list,new_length);
  printf("\ntime of execution of merge10000=%3d\n",(time(0)-sec));
  printf("\n\nHeapified list, after merging 10000 new elements, is :\n");
  for(i=0;i<length;i++)
  {
	  printf("%8d",*(list+i));
  }
  length=length-10000;
  i=0;
  do
  {  
	  *(new_list+i)=rand();
	  i++;
  }while(i!=20000);
  new_length=i-1;
  sec=time(0);
  length=merge(list,length,new_list,new_length);
  printf("\ntime of execution of merge20000=%3d\n",(time(0)-sec));
  printf("\n\nHeapified list, after merging 20000 new elements, is :\n");
  for(i=0;i<length;i++)
  {
	  printf("%8d",*(list+i));
  }
  
  sec=time(0);
  length=deleteMin(list,length);
  printf("\ntime of execution of deleteMin=%3d\n",(time(0)-sec));
  
  do
  {  
	  *(list+i)=rand();
	  i++;
  }while(i!=20000);
  length=i-1;
  createHeap(list,length);
  sec=time(0);
  sorting(list,length);
  printf("\ntime of execution of sorting=%3d\n",(time(0)-sec));
  printf("\n\nSorted list is :\n");
  for(i=0;i<length;i++)
  {
	  printf("%8d",*(list+i));
  }
}

/*I sinartisi createHeap exei tin ikanotita na metatrepei tin eisodo pou vazoume (diladi tin priority
queue) se ena heap*/
void createHeap ( int *list ,int length )
{
	int newnode;
    for(newnode=0;newnode<length;newnode++)
	{
	    int done=0, dad, temp;
        dad = ( newnode - 1 ) / 2;
        while( dad >= 0 && !done)
		{
            if(list[newnode] > list[dad])
			{
                temp = list[newnode];
                list[newnode]=list[dad];
                list[dad]=temp;
                newnode = dad;
                dad = dad/2;
			}
            else
                done = 1;

		}
  }

}

/*I sinartisi findMin exei san skopo na vriskei to min tou heap pou dexetai san eisodo
Episis einai orismeni oti epistrefei int, afto giati epistrefei tin timi min pou vriskei
Gia tin euresei tou min diatasei ta filla tou heap ta opoia exoun apothikefti se ena 
kainourgio deikti, o pointer aftos exei to onoma leaves
H diataksi tou ginetai me tin xrisi tou gnostou mas algorithmou QuickSort ton opoio edo
ton onomazoume Qsort*/  
int findMin(int *list, int length)
{
	 int length_leaves=0, *leaves, i, j=0;
     leaves = malloc(1000000*sizeof(int));
	 length_leaves=(length-1)/2+1;
	 for(i=length-length_leaves+1;i<length;i++)
	 {
		 *(leaves+j)=*(list+i);
	     j++;
	 }
	 i=0;
	 Qsort(leaves, i, length_leaves-1);
	 printf("\n\nMin=%d \n",*(leaves+1));
	 return *(leaves+1);
}

/*Prokeitai gia tin ilopoiisei tou algorithmou QuickSort*/
void Qsort(int *v, int left, int right)
{
	int i, last;
	void swap(int *v, int i, int j);

	if(left>=right)
		return;

	swap(v, left, (left+right)/2);
	last=left;
	for(i=left+1; i<=right; i++)
	{
		if((*(v+i))<(*(v+left)))
			swap(v, ++last, i);
	}
	swap(v,left, last);

	Qsort(v, left, last-1);
	Qsort(v, last+1, right);
}

/*I sinartisi afti enalasei dio stoixeia me vasei to an to ena einai megalitero
 i mikrotero apo to allo*/
void swap(int *v, int i, int j)
{
	int temp;

	temp=v[i];
	v[i]=v[j];
	v[j]=temp;
}

/*I sinartisi afti exei san skopo na eisagei ena kainourgio stoixeio sto heap,
to new_element, kai na afksanei argotera to length tou kainourgiou pleon heap
to opoio to kanei return*/
int insert(int *v, int length, int new_element)
{
	*(v+length)=new_element;
	length++;
	*(v+length)=-1;
	createHeap(v,length);
	return length;
}

/*I sinartisi afti exei san skopo sto heap v pou einai apothikeumeno  na sigxoneuete me 
alli mia priority queue w kai na epistrefei to megethos tou kainourgio heap to opoio 
einai prosafksimeno logo tis sigxoneusis aftis. */

int merge(int *v, int length_v, int *w, int length_w)
{
	int i;
	for(i=0;i<length_w;i++)
	{
		*(v+length_v+i)=*(w+i);
	}
	length_v=length_v+length_w;
	createHeap(v,length_v);
	return length_v;
}

/*I sinartisi afti exei san skopo na diagrafei to min apo to heap pou pairnei san orisma.
Episis epistrefei to megethos tou kainourgiou pleon heap pou os gnoston tha einai meiomeno
kata ena ogo tis diagrafis tou min */
int deleteMin(int *v, int length)
{
    int min, min_index, length_leaves, i;
	
	min=findMin(v,length-1);
    length_leaves=(length)/2+1;
	
	for(i=length-length_leaves+1;i<=length;i++)
	{
    	 if(*(v+i)==min)
		 { 
			 min_index=i;
		 }
	}

	v[min_index]=v[length-1];
	v[length-1]=-1;
	length--;
	createHeap(v, length-1);
	return length;
}

void sorting(int*v,int length)
{
	int i, counter,*reg;
	counter=length;
	reg=v;
	for(i=0;i<counter;i++)
	{
		createHeap(v,length);
		v++;
		length--;
	}
	v=reg;
	length=counter;
}
