#include<stdio.h>
#include<stdlib.h>

struct tnode
{
    struct tnode *parent;
	int key_value;
    struct tnode *left;
    struct tnode *right;
};


void zig_left(tnode *);
void zig_right(tnode *);
void zig_zig_left(tnode *);
void zig_zig_right(tnode *);
void zig_zag_left(tnode *);
void zig_zag_right(tnode *);
void Splay(tnode*, int );
int Compare_Key(int , int );
int Find(tnode* ,int );
void destroy_tree(tnode *);
struct tnode * insert(int ,tnode *);


int main()
{
	int i,counter,element;
	struct tnode *btree;
	printf("Give the number of the elements,\nthat you want to have your b-tree\n");
	scanf("%d",&counter);
	printf("Give the elements of the tree\n");
	btree=NULL;
	for(i=0;i<counter;i++)
	{
		scanf("%d",&element);
		btree=insert(element,btree);
	}
	do
	{
		printf("Give the element that you want to access\n");
		scanf("%d",&element);
		Find(btree,element);
	}while(element!=EOF);
	destroy_tree(btree);
	return 0;
}


void zig_left(tnode *tree)
{
    tnode    *par, *rig;
    par = tree->parent;
    rig = tree->right;
    tree->right = par;
    if (rig) {
        rig->parent = par;
    }
    par->left = rig;
    par->parent = tree;
}


void zig_right(tnode *tree)
{
    tnode    *par, *lef;
    lef = tree->left;
    par = tree->parent;
    par->right = tree;
    if (lef) {
        lef->parent = tree;
    }
    par->right = lef;
    par->parent = tree;
}


void zig_zig_left(tnode *tree)
{
    tnode    *par, *par_rig, *gran, *rig, *gran_par;
    par = tree->parent;
    gran = par->parent;
    gran_par = gran->parent;
    rig = tree->right;
    par_rig = par->right;
    par->right = gran;
    gran->left = par_rig;
    tree->parent = gran_par;
    tree->right = par;
    par->left = rig;
    if (rig) {
        rig->parent = par;
    }
    if (par_rig) {
        par_rig->parent = gran;
    }
    if (gran_par) {
        if (gran_par->left == gran) {
            gran_par->left = tree;
        }
        else {
            gran_par->right = tree;
        }
    }
}


void zig_zig_right(tnode *tree)
{
    tnode    *par, *par_lef, *gran, *lef, *gran_par;
    par = tree->parent;
    gran = par->parent;
    gran_par = gran->parent;
    lef = tree->left;
    par_lef = par->left;
    par->left = gran;
    gran->right = par_lef;
    tree->parent = gran_par;
    tree->left = par;
    par->right = lef;
    if (lef) {
        lef->parent = par;
    }
    if (par_lef) {
        par_lef->parent = gran;
    }
    if (gran_par) {
        if (gran_par->left == gran) {
            gran_par->left = tree;
        }
        else {
            gran_par->right = tree;
        }
    }
}

	
void zig_zag_left(tnode *tree)
{
    tnode    *par, *gran_par, *gran_gran_par, *lef, *rig;
    par = tree->parent;
    gran_par = par->parent;
    gran_gran_par = gran_par->parent;
    lef = tree->left;
    rig = tree->right;
    tree->parent = gran_gran_par;
    tree->left = par;
    tree->right = gran_par;
    gran_par->parent = tree;
    par->parent = tree;
    par->right = lef;
    gran_par->left = rig;
    if (lef) {
        lef->parent = par;
    }
    if (rig) {
        rig->parent = gran_par;
    }
    if (gran_gran_par) {
        if (gran_gran_par->left == gran_par) {
            gran_gran_par->left = tree;
        }
        else {
            gran_gran_par->right = tree;
        }
    }
}


void zig_zag_right(tnode *tree)
{
    tnode    *par, *gran_par, *gran_gran_par, *lef, *rig;
    par = tree->parent;
    gran_par = par->parent;
    gran_gran_par = gran_par->parent;
    lef = tree->left;
    rig = tree->right;
    tree->left = gran_par;
	tree->right = par;
    tree->parent = gran_gran_par;
    par->parent = tree;
	gran_par->parent = tree;
    gran_par->right = lef;
    par->left = rig;
    if (lef) {
        lef->parent = gran_par;
    }
    if (rig) {
        rig->parent = par;
    }
    if (gran_gran_par) {
        if (gran_gran_par->left == gran_par) {
            gran_gran_par->left = tree;
        }
        else {
            gran_gran_par->right = tree;
        }
    }
}

/*sigkrinei 2 int kai an einai isoi epistrefei 0, an einai o protos megaliteros 
epistrefei 1 allios -1*/
int Compare_Key(int k1, int k2)
{
	if(k1=k2)
		return 0;
	else if(k1>k2)
		return 1;
	else
		return -1;
}


void Splay(tnode *tree,int k)
{
    int gle;
    while ((gle = Compare_Key(tree->key_value,k)) != 0) {
        if (gle > 0) {
            if (tree->left) {
                tree = tree->left;
            }
            else break;
        }
        else {
            if (tree->right) {
                tree = tree->right;
            }
            else break;
        }
    }
    while (tree->parent != tree) {
        if (tree->parent->parent) {
            if (tree->parent->parent->left == tree->parent) {
                if (tree->parent->left == tree) {
                    zig_zig_left(tree);
                }
                else {
                    zig_zag_left(tree);
                }
            }
            else {
                if (tree->parent->right == tree) {
                    zig_zig_right(tree);
                }
                else {
                    zig_zag_right(tree);
                }
            }
        }
        else {
            if (tree->parent->left == tree) {
                zig_left(tree);
            }
            else {
                zig_right(tree);
            }
        }
    }
}

/*h sinartisi afti vriskei an iparxei to k sto dentro kai
an nai epistrefei afto allios petaei analogo minima*/ 
int Find(tnode *tree ,int k)
{
    Splay(tree,k);
    if (tree->key_value == k) {
        return (tree->key_value);
    }
    else {
        printf("That doesn't exist\n");
    }
}

//diagrafei to dentro
void destroy_tree(tnode *leaf)
{
  if(leaf!=NULL)
  {
    destroy_tree(leaf->left);
    destroy_tree(leaf->right);
    delete leaf;
  }
}

//prosthetei neo komvo sto b-tree 
struct tnode * insert(int element,tnode *leaf)
{
	if(leaf!=NULL)
	{
		if(element< leaf->key_value)
		{
            if(leaf->left!=NULL)
				insert(element, leaf->left);
            else
			{
				leaf->left=new tnode;
                leaf->left->key_value=element;
	            leaf->left->parent=leaf;
                leaf->left->left=NULL;   
                leaf->left->right=NULL;  
			}  
		}
		else if(element>=leaf->key_value)
		{
            if(leaf->right!=NULL)
				insert(element, leaf->right);
            else
			{
				leaf->right=new tnode;
                leaf->right->key_value=element;
	            leaf->right->parent=leaf;
                leaf->right->left=NULL;  
                leaf->right->right=NULL; 
			}
		}
	}
    else
	{
		leaf=new tnode;
        leaf->key_value=element;
        leaf->left=NULL;
        leaf->right=NULL;
	}
    return leaf;
}
